unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellAPI, SHUtilityProxy
  {Project}
  , ActnRsyncU
  ;

type
  TForm1 = class(TForm)
    CopyButt: TButton;
    RenameButt: TButton;
    Log: TMemo;
    CopyFromEdit: TEdit;
    CopyToEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    RenameFromEdit: TEdit;
    RenameToEdit: TEdit;
    CommandButt: TButton;
    KeyGenButt: TButton;
    UploadKeyButt: TButton;
    procedure CopyButtClick(Sender: TObject);
    procedure RenameButtClick(Sender: TObject);
    procedure CommandButtClick(Sender: TObject);
    procedure KeyGenButtClick(Sender: TObject);
    procedure UploadKeyButtClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.CommandButtClick(Sender: TObject);
begin
  /// Open a DOS box and run a command that returns something (any command)
  /// Leave the DOS box open
  ///
  /// Not necessary for the project, just proving cmd.exe works (and command.com does not)

  // Command lists contents of current folder.
  // "/k" to keep window open after execution
  ShellExecute(Handle, 'open', PChar('cmd.exe'), PChar('/k dir'), nil, SW_SHOWNORMAL);
end;

procedure TForm1.CopyButtClick(Sender: TObject);
begin
  // Copy a file from the client to the server
  TActnRsync.RunCommandSilent(TActnRsync.Copy(CopyFromEdit.Text, CopyToEdit.Text, false), Log.Lines);
end;

procedure TForm1.KeyGenButtClick(Sender: TObject);
begin
  /// Generate SSH key-pair.
  /// Will open a DOS box.
  /// User should press return to all prompts, this accepting defaults
  ShellExecute(Handle, 'open', PChar('ssh-keygen.exe'), nil, nil, SW_SHOW);
end;

procedure TForm1.RenameButtClick(Sender: TObject);
begin
  // Rename a file on the server
  TActnRsync.RunCommandSilent(TActnRsync.Move(RenameFromEdit.Text, RenameToEdit.Text), Log.Lines);
end;

procedure TForm1.UploadKeyButtClick(Sender: TObject);
begin
  // Upload the the public key created in KeyGenButtClick() to the server
  TActnRsync.UploadKey(Log.Lines);
end;

end.
